package com.titanshark.clevermenu;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import org.apache.cordova.*;
import android.widget.*;
import android.view.Window;
import android.view.View;
import android.view.WindowManager;
import android.view.KeyEvent;
import android.view.ViewGroup.LayoutParams;
import java.util.Timer;
import java.util.TimerTask;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import android.preference.PreferenceManager;
import android.content.SharedPreferences;
import android.content.pm.ApplicationInfo;
import android.content.pm.PackageManager;
import android.content.pm.ResolveInfo;
import android.content.SharedPreferences;
import android.preference.PreferenceManager;
import java.util.ArrayList;
import java.util.List;
import android.content.ComponentName;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.PowerManager;
import android.content.Context;
import android.os.Build;
import android.app.KeyguardManager;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager;
import org.json.JSONObject;
import android.view.WindowManager;

public class CleverMenuPlugin extends CordovaPlugin {
    
	public static final String ACTION_WAKE_DEVICE_UP = "ACTION_WAKE_DEVICE_UP";
	public static final String ACTION_GET_APK_INFO = "ACTION_GET_APK_INFO";
	public static final String ACTION_TEST = "TEST";
	

	public void onActivityResult(int requestCode, int resultCode, Intent intent) {
		Toast.makeText(cordova.getActivity(), "onActivityResult: " + requestCode + ", " + resultCode, Toast.LENGTH_LONG).show();
	}

    @Override
    public boolean execute(String action, JSONArray args, final CallbackContext callbackContext) throws JSONException {
        try {	
			if(ACTION_WAKE_DEVICE_UP.equals(action)){
				cordova.getActivity().runOnUiThread(new Runnable() {
					@Override
					public void run() {	
						PowerManager pm = (PowerManager) cordova.getActivity().getSystemService(Context.POWER_SERVICE);
						boolean isScreenOn = false;
						if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.KITKAT_WATCH) {
							isScreenOn = pm.isInteractive();
						} else if (Build.VERSION.SDK_INT < Build.VERSION_CODES.KITKAT_WATCH) {
							isScreenOn = pm.isScreenOn();
						}

						if (!isScreenOn) {
							try{
								Intent intent = new Intent(cordova.getActivity(), WakeUpActivity.class);
								cordova.getActivity().startActivity(intent);
								//Toast.makeText(cordova.getActivity(), "Testing: Wake up finished", Toast.LENGTH_LONG).show();
							}catch(Exception ex){
								Toast.makeText(cordova.getActivity(), "Error: " + ex.getMessage() + isScreenOn, Toast.LENGTH_LONG).show();
							}
						}
						callbackContext.success();
					}
				});	
				
                return true;
			}else if(ACTION_GET_APK_INFO.equals(action)){
				try {
					PackageManager manager = cordova.getActivity().getPackageManager();
					PackageInfo info = manager.getPackageInfo(cordova.getActivity().getPackageName(), 0);
					JSONObject result = new JSONObject();
					result.put("versionName", info.versionName);
					result.put("versionCode", info.versionCode);
					callbackContext.success(result);
				}catch (Exception ex){}
			}else if(ACTION_TEST.equals(action)){
				Toast.makeText(this.cordova.getActivity(), "testing....", Toast.LENGTH_LONG).show();
			}
			
            callbackContext.error("Invalid action");
            return false;
        } catch(Exception e) {
            System.err.println("Exception: " + e.getMessage());
            callbackContext.error(e.getMessage());
            return false;
        }
    }
}

