package com.titanshark.clevermenu;

import android.app.Activity;

import android.os.Bundle;
import android.os.Handler;
import android.view.Window;
import android.view.WindowManager;
import android.os.PowerManager;
import android.os.Build;
import android.content.Context;
import android.widget.Toast;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.view.View;
import android.view.Gravity;
import android.graphics.Color;

public class WakeUpActivity extends Activity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN,
                WindowManager.LayoutParams.FLAG_FULLSCREEN);
        getWindow().addFlags(WindowManager.LayoutParams.FLAG_SHOW_WHEN_LOCKED
                | WindowManager.LayoutParams.FLAG_DISMISS_KEYGUARD
                | WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON
                | WindowManager.LayoutParams.FLAG_TURN_SCREEN_ON
                | WindowManager.LayoutParams.FLAG_ALLOW_LOCK_WHILE_SCREEN_ON);

		LinearLayout linearLayout = new LinearLayout(this);
        linearLayout.setOrientation(LinearLayout.VERTICAL);
        linearLayout.setLayoutParams(new LinearLayout.LayoutParams(LinearLayout.LayoutParams.MATCH_PARENT, LinearLayout.LayoutParams.MATCH_PARENT));
        linearLayout.setBackgroundColor(Color.WHITE);
        linearLayout.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                finish();
            }
        });

        TextView textView = new TextView(this);
        textView.setLayoutParams(new LinearLayout.LayoutParams(LinearLayout.LayoutParams.MATCH_PARENT, LinearLayout.LayoutParams.MATCH_PARENT));
        textView.setGravity(Gravity.CENTER);
        textView.setText("Touch to close");

        linearLayout.addView(textView);
        setContentView(linearLayout);
    }

    @Override
    protected void onResume() {
        super.onResume();
		new Thread(new Runnable() {
            @Override
            public void run() {
                checkScreenOn();
            }
        }).start();		
    }

	private void checkScreenOn(){
        while (true){
            try{
                PowerManager pm = (PowerManager) getSystemService(Context.POWER_SERVICE);
                boolean isScreenOn = false;
                if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.KITKAT_WATCH) {
                    isScreenOn = pm.isInteractive();
                } else if (Build.VERSION.SDK_INT < Build.VERSION_CODES.KITKAT_WATCH) {
                    isScreenOn = pm.isScreenOn();
                }
                if(isScreenOn){
                    break;
                }
                Thread.sleep(100);
            }catch (Exception ex){
				Toast.makeText(this, "Error: " + ex.getMessage(), Toast.LENGTH_LONG).show();
			}
        }

		runOnUiThread(new Runnable() {
            @Override
            public void run() {
                finish();
            }
        });        
    }
}
